'
'                ********* D I S C L A I M E R *********
'  Use of this program is at the discretion of the user.  Archimation makes
'  no claims or warranty as to its accuracy and will not be held liable for
'  loss of or alteration to any computer images from its use.
'
'
' ******  3 D   S T U D I O   N U M B E R   S Q U E E Z E R  v1.1  ******
'      Archimation P.O. 835  Utica, New York 13503  Tel. 315/732-3013
'
' Keyframe images with extensions such as TGA that are rendered using an
' increment value greater than one must be renumbered  consecutively to be
' composited in Video Post.
'
' SQUEEZER does the work for you quickly and easily. Written in QBASIC,
' SQUEEZER uses a 12 character name such as IMAG0000.TGA and renumbers them
' in consecutive order.

' As an example, if the number of Targa images to be rendered were 140
' using an increment of 20 steps, then 7 images files would be created
' (not including an image with a number 0000.TGA.) as follows:
'
' IMAG0000.TGA  IMAG0020.TGA  IMAG0040.TGA  IMAG0060.TGA  IMAG0080.TGA
' IMAG0100.TGA  IMAG0120.TGA  IMAG0140.TGA
'
' The image files to be renumbered would be IMAG*.TGA. A wildcard character
' is used in place of the file number. The minimum image file number would
' be 20, the maximum file number would be 140, and the file increment value
' would be 20.  When SQUEEZER is run, the previous image files are renumbered
' as follows:
'
' IMAG0000.TGA  IMAG0001.TGA  IMAG0002.TGA  IMAG0003.TGA  IMAG0004.TGA
' IMAG0005.TGA  IMAG0006.TGA  IMAG0007.TGA
'
' A selective range of files can be renumbered by adjusting the minimum and
' maximum image file number. For example, suppose you rendered IMAG0020.TGA,
' IMAGE0040.TGA and IMAG0060.TGA. with an increment of 20 steps and ran
' SQUEEZER to renumber them IMAG0001.TGA, IMAG0002.TGA, and IMAG0003.TGA.

' Later you created images IMAG0080.TGA thru IMAG0140.TGA with an increment
' of 20 steps and needed renumbering to begin at IMAG0004.TGA and end at
' IMAG0007.TGA.  The minimum image file number would be 80, the maximum file
' number would be 140, and the file increment value would still be 20.  When
' SQUEEZER is run, the image files are renumbered as follows:
'
' IMAG0004.TGA  IMAG0005.TGA  IMAG0006.TGA  IMAG0007.TGA
'
' Create a Batch file to run the program.  If SQUEEZER is on Drive C, type
' Edit and a name for the batch file such as SQZ.BAT.  Type the following
' lines in the new batch file:
'      CLS
'      @ECHO OFF
'      QBASIC /RUN C:\SQUEEZER.BAS
' Save the batch file.  Whenver you need to run SQUEEZER,  type SQZ from
' Drive C and QBASIC and SQUEEZER up and running.
'
'
'          ********* P R O G R A M   V A R I A B L E S *********
' COLORS
'
    '1 BLUE       9  BLUE        17 BR BLUE         25 BLNK BLUE
    '2 GREEN      10 BR GREEN    18 BLNK LT GREEN   26 BLNK GREEN
    '3 LHT BLUE   11 BR BLUE     19 BLNK LT BLUE    27 BLNK LT BLUE
    '4 RED        12 BR RED      20 BLNK RED        28 BLNK LT RED
    '5 PRUPLE     13 BR PURPLE   21 BLNK PURPLE     29 BLNK BLACK
    '6 BROWN      14 BR YELLOW   22 BLNK BROWN      30 BLNK YELLOW
    '7 WHITE      15 BR WHITE    23 BLNK WHITE
    '8 GREY       16 BLACK       24 BLNK GREY
'
' PROGRAM VARIABLES
'
    ' DRV$  DISK DRIVE           STP   FRAME INCREMENT NUMBER
    ' DIR$  DIRECTORY            STA   START NUMBER OF IMAGE FILES
    ' FLS$  FILES                IMG   LAST  NUMBER OF IMAGE FILES
    ' ANS$  ANSWER VARIABLE      OFR() DIMENSIONED OLD IMAGE ARRAY
    ' NME$  EXISTING FILE NAME   NFR() DIMENSIONED NEW IMAGE ARRAY
    ' EXT$  FILE EXTENSION       CNT   COUNTER VARIABLE
'
DIM OFR(250) AS STRING
DIM NFR(250) AS STRING
DEFINT A-Z
CLEAR , , 3600

FINDDRIVE:
    CLS
    GOSUB TITLE
    LOCATE 7, 1
    INPUT "Change to Drive: (ie: C) "; DRV$
    IF LEN(DRV$) > 1 THEN DRV$ = LEFT$(DRV$, 1)
    LOCATE 7, 1: ROWPOS = CSRLIN
       ON ERROR GOTO FILERR1
       PRINT "Here is a listing of the Directories and Files": PRINT
       CHDIR DRV$ + ":\": FILES DRV$ + ":\": PRINT : PRINT
       COLOR 14: BEEP
           INPUT "Is the Directory or Files located on this Drive (ENTER/N) "; ANS$
           COLOR 7: ROWPOS = CSRLIN
           IF ANS$ = "N" OR ANS$ = "n" THEN CUR = 7: GOSUB CLRSCRN: GOTO FINDDRIVE
    LOCATE ROWPOS - 1, 1
    PRINT "                                                                    "
    LOCATE ROWPOS - 1, 1

DIRECTORIES:
    INPUT "Directories to Search: (ie: 3DS4/FLICS or Enter) "; DIR$
    IF DIR$ = "" THEN CUR = 7: ROWPOS = CSRLIN: GOTO VIEWIMAGES
    BEEP: CUR = 7: GOSUB CLRSCRN: LOCATE 7, 1: ROWPOS = CSRLIN
    ON ERROR GOTO FILERR2
    PRINT "Here is a listing of the Files": PRINT
       CHDIR DRV$ + ":\" + DIR$
       FILES DRV$ + ":\" + DIR$ + "\*.*": PRINT
       COLOR 14
       BEEP
       INPUT "Are the Files located in this Directory correct (ENTER/N) "; ANS$
           COLOR 7
           ROWPOS = CSRLIN - 1: CUR = ROWPOS: GOSUB CLRSCRN: LOCATE ROWPOS, 1
           IF ANS$ = "N" OR ANS$ = "n" THEN CUR = 7: GOSUB CLRSCRN: GOTO FINDDRIVE
      
VIEWIMAGES:
       BEEP
       IF DIR$ = "" THEN LOCATE ROWPOS - 1, 1
       INPUT "Select image files to be renumbered (ie:IMAG*.TGA) "; FLS$: PRINT
       BEEP: CUR = 7: GOSUB CLRSCRN: LOCATE 7, 1
       ON ERROR GOTO FILERR3
       PRINT "Here is a listing of the selected files in"
       IF DIR$ = "" THEN FILES DRV$ + ":\" + FLS$: PRINT : GOTO GETIMAGES
       PRINT : BEEP
       FILES DRV$ + ":\" + DIR$ + "\" + FLS$: PRINT
  
GETIMAGES:
    INPUT "Enter minimum image file number other than 0 (ie: 2) "; STA
    ROWPOS = CSRLIN: CUR = ROWPOS - 1: GOSUB CLRSCRN: LOCATE ROWPOS - 1, 1: CUR1 = ROWPOS
    INPUT "Enter maximum image file number (ie: 250) "; IMG
    ROWPOS = CSRLIN: CUR = ROWPOS - 1: GOSUB CLRSCRN: LOCATE ROWPOS - 1, 1: CUR1 = ROWPOS
    INPUT "Enter value of image file increment (ie: 2) "; STP
    IF STP < 2 THEN STP = STA
    CNT = ((IMG - STA) / STP) + 1
    EXT$ = RIGHT$(FLS$, 4)
    NME$ = LEFT$(FLS$, 4)

OLDIMAGES:
    FOR X = STA TO IMG STEP STP
       IF X < 10 THEN OFR(X / STP) = NME$ + "000" + RIGHT$(STR$(X), 1) + EXT$
       IF X >= 10 AND X < 100 THEN OFR(X / STP) = NME$ + "00" + RIGHT$(STR$(X), 2) + EXT$
       IF X >= 100 THEN OFR(X / STP) = NME$ + "0" + RIGHT$(STR$(X), 3) + EXT$
    NEXT X
    
CONTINUE:
    PRINT : PRINT
    FST = STA / STP
       IF FST < 10 THEN F$ = "000" + RIGHT$(STR$(FST), 1)
       IF FST >= 10 AND FST < 100 THEN F$ = "00" + RIGHT$(STR$(FST), 2)
       IF FST >= 100 THEN F$ = "0" + RIGHT$(STR$(FST), 3)
    LST = IMG / STP
       IF LST < 10 THEN L$ = "000" + RIGHT$(STR$(LST), 1)
       IF LST >= 10 AND LST < 100 THEN L$ = "00" + RIGHT$(STR$(LST), 2)
       IF LST >= 100 THEN L$ = "0" + RIGHT$(STR$(LST), 3)
    COLOR 15
    CUR = ROWPOS - 1: GOSUB CLRSCRN: LOCATE ROWPOS - 1, 1: CUR1 = ROWPOS
    PRINT "IMAGE FILES TO BE RENUMBERED ARE: "; CNT
    PRINT "SELECTED IMAGE FILES ARE: " + OFR(STA / STP) + " THRU " + OFR(IMG / STP) + " -INCREMENT:"; STP
    COLOR 12
    PRINT "NEW IMAGE FILES  WILL BE: " + NME$ + F$ + EXT$; " THRU " + NME$ + L$ + EXT$ + " -INCREMENT: 1"
    PRINT "IMAGE FILE "; NME$ + "0000" + EXT$ + " WILL NOT BE MODIFIED"
    BEEP: PRINT : COLOR 14
           INPUT "Are the file increment and file numbers correct (ENTER/N) "; ANS$
           COLOR 7
           IF ANS$ = "N" OR ANS$ = "n" THEN CUR = CUR1 - 1: GOSUB CLRSCRN: LOCATE CUR1 - 1, 1: GOTO GETIMAGES
    ROWPOS = CSRLIN - 1: CUR = ROWPOS: GOSUB CLRSCRN
    LOCATE ROWPOS, 1
    COLOR 11
    INPUT "Do you wish to renumber selected images (ENTER/N)"; ANS$
    ROWPOS = CSRLIN
    IF ANS$ = "N" OR ANS$ = "n" THEN GOTO NOSQUEEZE

NEWIMAGES:
    FOR X = FST TO LST
       IF X < 10 THEN NFR(X) = NME$ + "000" + RIGHT$(STR$(X), 1) + EXT$
       IF X >= 10 AND X < 100 THEN NFR(X) = NME$ + "00" + RIGHT$(STR$(X), 2) + EXT$
       IF X >= 100 THEN NFR(X) = NME$ + "0" + RIGHT$(STR$(X), 3) + EXT$
    NEXT X
    
NAMEIMAGES:
   ON ERROR GOTO FILERR4
   FOR X = FST TO LST
   IF DIR$ = "" THEN
      NAME DRV$ + ":\" + OFR(X) AS DRV$ + ":\" + NFR(X)
   ELSE NAME DRV$ + ":\" + DIR$ + "\" + OFR(X) AS DRV$ + ":\" + DIR$ + "\" + NFR(X)
   END IF
   NEXT X
   
FINISH:
    GOSUB TITLE
    COLOR 30
    LOCATE 20, 1
    BEEP
    PRINT "                  I M A G E              C O M P L E T E"
    LOCATE 20, 30: COLOR 21: PRINT "S Q U EEZE"
    FOR X = 1 TO 4: BEEP: SLEEP 1: NEXT X: SLEEP 2: COLOR 7
    CLS
    GOTO SHOWSQUEEZE

NOSQUEEZE:
    GOSUB TITLE
    COLOR 30: LOCATE 19, 1
    PRINT "                              PROGRAM TEMINATED"
    COLOR 23: LOCATE 20, 1
    PRINT "                  I M A G E S   N O T   S Q U E E Z E D "
    COLOR 7
    FOR X = 1 TO 4: BEEP: SLEEP 1: NEXT X: SLEEP 3
    CLS
END

TITLE:
    CLS
    COLOR 10: LOCATE 3, 16: PRINT "3 D   S T U D I O   N U M B E R"
    COLOR 13: LOCATE 3, 49: PRINT "S Q UEEZER "
    COLOR 12: LOCATE 4, 27: PRINT "A r c h"
    COLOR 15: LOCATE 4, 35: PRINT "i m a t i o n"
    PRINT : PRINT
    COLOR 7
    RETURN

CLRSCRN:
   FOR I = CUR TO 23
   LOCATE I, 1
   PRINT "                                                                              "
   NEXT I
   RETURN

FILERR1:
   CUR = 7: GOSUB CLRSCRN
   COLOR 28
   LOCATE ROWPOS, 1
   PRINT "SELECTED DEVICE UNAVAILABLE"
   FOR SND = 1 TO 2: SOUND 100, 2: SOUND 500, 2: SOUND 1000, 2: NEXT SND
   SLEEP 2: COLOR 7
   RESUME FINDDRIVE

FILERR2:
   CUR = ROWPOS - 1: GOSUB CLRSCRN
   LOCATE ROWPOS, 1
    PRINT "Here is a listing of the Files": PRINT
       CHDIR DRV$ + ":\"
       FILES DRV$ + ":\": PRINT
  COLOR 28: ROWPOS = CSRLIN
  PRINT "DIRECTORY "; DIR$; " NOT FOUND"
   FOR SND = 1 TO 2: SOUND 100, 2: SOUND 500, 2: SOUND 1000, 2: NEXT SND
   SLEEP 2: COLOR 7
   LOCATE ROWPOS, 1
   RESUME DIRECTORIES

FILERR3:
   LOCATE 7, 1
   PRINT "Here is a listing of the Files": PRINT
   IF DIR$ = "" THEN GOSUB NODIR
   CHDIR DRV$ + ":\" + DIR$
   FILES DRV$ + ":\" + DIR$ + "\*.*"
   LOCATE ROWPOS, 1
   COLOR 28: PRINT "FILES NOT FOUND"
   FOR SND = 1 TO 2: SOUND 100, 2: SOUND 500, 2: SOUND 1000, 2: NEXT SND
   SLEEP 2: COLOR 7
   LOCATE ROWPOS, 1
   RESUME VIEWIMAGES
  
NODIR:
   CUR = 7: GOSUB CLRSCRN: LOCATE 7, 1
   PRINT "Here is a listing of the Files": PRINT
   FILES DRV$ + ":\" + DIR$
   COLOR 28: PRINT
   LOCATE ROWPOS - 1, 1
   PRINT "FILES NOT FOUND"
   FOR SND = 1 TO 2: SOUND 100, 2: SOUND 500, 2: SOUND 1000, 2: NEXT SND
   SLEEP 2: COLOR 7
   RESUME VIEWIMAGES

FILERR4:
   CUR = ROWPOS - 1: GOSUB CLRSCRN
   LOCATE ROWPOS - 1, 1
   COLOR 23
   PRINT "FILE NUMBERS NOT SQUEEZED";
   COLOR 28: PRINT " ERROR IN NAMEFILE"
   COLOR 7
   END

SHOWSQUEEZE:
   CLS
   X2 = FST + 1: X3 = FST + 2: HL = 1
   CUR = 1: GOSUB CLRSCRN: GOSUB TITLE: LOCATE 7, 1
   PRINT "Here is a listing of the renumbered images:"
   IF FST = 1 THEN LOCATE 9, 1: COLOR 7: PRINT NME$ + "0000" + EXT$ + "-": COLOR 12: LOCATE 9, 14: PRINT NME$ + "0000" + EXT$
       FOR X = FST TO LST STEP 3
           IF X = LST THEN COLOR 7: LOCATE 9 + HL, 1: PRINT OFR(X); "-": COLOR 12: LOCATE 9 + HL, 14: PRINT NFR(X): COLOR 7: END
              COLOR 7: LOCATE 9 + HL, 1: PRINT OFR(X); "-": COLOR 12: LOCATE 9 + HL, 14: PRINT NFR(X)
           IF X2 = LST THEN COLOR 7: LOCATE 9 + HL, 27: PRINT OFR(X2); "-": COLOR 12: LOCATE 9 + HL, 40: PRINT NFR(X2): COLOR 7: END
              COLOR 7: LOCATE 9 + HL, 27: PRINT OFR(X2); "-": COLOR 12: LOCATE 9 + HL, 40: PRINT NFR(X2)
           IF X3 = LST THEN COLOR 7: LOCATE 9 + HL, 53: PRINT OFR(X3); "-": COLOR 12: LOCATE 9 + HL, 66: PRINT OFR(X3): COLOR 7: END
              COLOR 7: LOCATE 9 + HL, 53: PRINT OFR(X3); "-": COLOR 12: LOCATE 9 + HL, 66: PRINT NFR(X3)
           X2 = X2 + 3: X3 = X3 + 3: HL = HL + 1
           IF HL > 12 THEN HL = 1: GOSUB SCROLL
           NEXT X
           COLOR 7
           END

SCROLL:
    COLOR 14: LOCATE 23, 1
    PRINT "Press SPACE BAR to view next screen."
    DO
    LOOP UNTIL INKEY$ = CHR$(32): 'LOOP UNTIL SPACE BAR IS PRESSED
    GOSUB TITLE
    COLOR 7
    RETURN

